﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO;

namespace DockPaneSample
{
	public partial class Form1 : Form
	{
		private List<Button> dockControls = new List<Button>();
		private string mySettingPath = "Settings.txt";
		private string dockSettingPath = "Settings.xml";

		public Form1()
		{
			InitializeComponent();
		}

		private Button CreateDockControl()
		{
			Button dockControl = new Button();
			dockControl.Name = dockControl.Text = "Dock Control " + dockControls.Count;
			dockControls.Add(dockControl);
			return dockControl;
		}

		private void button1_Click(object sender, EventArgs e)
		{
			Button dockControl = this.CreateDockControl();
			this.ultraDockManager1.DockControls(
				new Control[] { dockControl }, 
				Infragistics.Win.UltraWinDock.DockedLocation.DockedLeft, 
				Infragistics.Win.UltraWinDock.ChildPaneStyle.VerticalSplit);
		}

		private void button2_Click(object sender, EventArgs e)
		{
			this.ultraDockManager1.SaveAsXML(dockSettingPath);

			using(FileStream fs = new FileStream(mySettingPath, FileMode.Create))
			using (StreamWriter writer = new StreamWriter(fs))
			{
				writer.Write(dockControls.Count);
			}
		}

		private void button3_Click(object sender, EventArgs e)
		{
			for (int i = 0; i < this.dockControls.Count; i++)
				this.dockControls[i].Dispose();

			this.dockControls.Clear();

			using (Panel tmpPanel = new Panel())
			{
				tmpPanel.Visible = false;
				tmpPanel.Parent = this;

				if (File.Exists(mySettingPath))
				{
					using (FileStream fs = new FileStream(mySettingPath, FileMode.Open))
					using (StreamReader reader = new StreamReader(fs))
					{
						int dockControlsCount = Int32.Parse(reader.ReadLine());
						for (int i = 0; i < dockControlsCount; i++)
							tmpPanel.Controls.Add(this.CreateDockControl());
					}
				}

				if (File.Exists(dockSettingPath))
					this.ultraDockManager1.LoadFromXML(dockSettingPath);

				tmpPanel.Parent = null;
				tmpPanel.Dispose();
			}
		}
	}
}
